var msgID = 0;
var offsetDelta = 0;
var msgLimit = 40;
var pollUri = "poll";
var pollInterval = 200;
var inProcess = false;

$(function() {
  offsetDelta = $("#messages").offset().top - $("#messagesWrapper").offset().top;
  $("#msgForm").ajaxForm({
    beforeSubmit:beforeSend, 
    success:afterSend
  });
 
  setInterval(pollRequest, pollInterval);
  pollRequest();
 
  function pollRequest() {
    if(!inProcess) {
      inProcess = true;
      $.ajax(pollUri, {
        data:{
          after: msgID
        }, 
        dataType: "xml", 
        error: msgError, 
        success: msgSuccess
      })
    }
  }
})

function beforeSend(args) {
  for(var i = 0; i < args.length; i++)
    if(!args[i].value)
      return false; 
  return true;
}

function afterSend() {
  $("#textField").val("");
  $("#textField").focus();
}

function msgError() {
  inProcess = false;
}

function msgSuccess(data) {
  var msgs = $(data).find("msg");
  if(msgs.length) {
    // scroll is bottomed
    var h0 = $("#messagesWrapper").height();
    var h1 = $("#messages").height();
    var offsetMsg = $("#messagesWrapper").offset().top - $("#messages").offset().top + offsetDelta;
    var autoScroll = (offsetMsg + h0 >= h1);
  
    for(var i = 0; i < msgs.length; i++) {
      var id = $(msgs[i]).find("id").text();
      var nic = $(msgs[i]).find("nic").text();
      var text = $(msgs[i]).find("text").text();
      var time = $(msgs[i]).find("stamp").text();
      msgID = id;
      var msgDiv = '<div id="msg-'+id+'" class="msg"><div class="nic">'+nic+'</div><div class="time">'+time+'</div><div class="text">'+text+'</div></div>';
      $("#messages").append(msgDiv);
    }
  
    var msgsOut = $(".msg", "#messages").length - msgLimit;
    if(msgsOut > 0)
      for(i = 0; i < msgsOut; i++)
        $(".msg", "#messages").first().remove();
    if(autoScroll)
      $("#messagesWrapper").scrollTop(h1);
  }
  inProcess = false;
}
